#include "Manager.h"
#include"Exceptions.h"
#pragma warning(disable:4996)
Manager::Manager() {
	centeredPrint("##########################################");
	centeredPrint("##           ѧɼϵͳ           ##");
	centeredPrint("##########################################");
	cout << endl;
	centeredPrint("...");

	ifstream numsin("nums.bin", ios::in, ios::binary);
	if (!numsin.good()) {
		ExamNum = 0;
		StudentNum = 0;
		numsin.close();
		return;
	}
	numsin.read((char*)&StudentNum, sizeof(int));
	numsin.read((char*)&ExamNum, sizeof(int));
	numsin.close();
	ifstream studentsin("students.bin", ios::in, ios::binary);
	Student tmpstu;
	for (int i = 0; i < StudentNum; i++) {
		studentsin.read((char*)&tmpstu, sizeof(Student));
		Students.push_back(tmpstu);
	}
	studentsin.close();
	ifstream examsin("examsaves.bin", ios::in, ios::binary);
	Examsave tmpexam;
	for (int i = 0; i < ExamNum; i++) {
		examsin.read((char*)&tmpexam, sizeof(Examsave));
		auto sp1 = make_shared<Exam>(&tmpexam);
		Exams.push_back(sp1);
	}
	examsin.close();

	cout << endl;
	centeredPrint("ӭʹ!");
}
Manager::~Manager() {
	centeredPrint("...");
	ofstream examsout("examsaves.bin", ios::out, ios::binary);
	for (auto i = Exams.begin(); i < Exams.end(); i++) {
		(*i)->saveAll(examsout);
	}
	ExamNum = Exams.size();
	examsout.close();
	ofstream studentsout("students.bin", ios::out, ios::binary);
	for (auto i = Students.begin(); i < Students.end(); i++) {
		studentsout.write((char*)&(*i), sizeof(Student));
	}
	StudentNum = Students.size();
	studentsout.close();
	ofstream numsout("nums.bin", ios::out, ios::binary);
	numsout.write((char*)&StudentNum, sizeof(int));
	numsout.write((char*)&ExamNum, sizeof(int));
	numsout.close();
	centeredPrint("ѱ棡");
}
void Manager::mainLoop() {
	
	while (1) {
		try {
			switch (status) {
			case 0:
				welcomePage();
				break;
			case 1:
				stuPage();
				break;
			case 11:
				stuDspPage();
				break;
			case 12:
				stuAddPage();
				break;
			case 13:
				stuSearchPage();
				break;
			case 14:
				stuEdtRmvPage();
				break;
			case 15:
				stuExportPage();
				break;
			case 16:
				stuImportPage();
				break;
			case 2:
				examPage();
				break;
			case 21:
				examAddPage();
				break;
			case 22:
				examChoosePage();
				break;
			case 23:
				examSubPage();
				break;
			case 231:
				examViewPage();
				break;
			case 232:
				examExportPage();
				break;
			case 233:
				examAddRowPage();
				break;
			case 234:
				examDelRowPage();
				break;
			case 235:
				examNamePage();
				break;
			case 236:
				examImportPage();
				break;
			case 237:
				examRmvPage();
				break;
			case 3:
				stuPfmPage();
				break;
			}
			system("cls");
			if (status == -1)
				break;
		}
		catch (const InputError& e) {
			system("cls");
			cerr << e.what() << endl;
			cin.clear();
			cin.ignore(1024,'\n');
			goBack();
		}
		catch (const FileError& e) {
			system("cls");
			cerr << e.what() << endl;
			goBack();
		}
		catch (const IndexError& e) {
			system("cls");
			cerr << e.what() << endl;
			goBack();
		}
	}
	


}
void Manager::goBack() {
	status /= 10;
}
void Manager::centeredPrint(const string& content) {
	HANDLE hOutput = GetStdHandle(STD_OUTPUT_HANDLE);
	CONSOLE_SCREEN_BUFFER_INFO bInfo;
	GetConsoleScreenBufferInfo(hOutput, &bInfo);
	int dwSizeX = bInfo.dwSize.X, dwSizeY = bInfo.dwSize.Y;
	int cursorX = bInfo.dwCursorPosition.X, cursorY = bInfo.dwCursorPosition.Y;
	int len = content.length();
	COORD pos;
	pos.X = (dwSizeX - len) / 2;
	pos.Y = cursorY;
	SetConsoleCursorPosition(hOutput, pos);
	cout << content << endl;
}
Student* Manager::searchByNo(long long int studentNo) {
	for (auto i = Students.begin(); i < Students.end(); i++) {
		if (i->stuNoEqual(studentNo)) {
			return &(*i);
		}
	}
	return nullptr;
}
//status 0
void Manager::welcomePage() {
	char choice = '0';
	cout << "˵" << endl;
	cout << "ѡ" << endl;
	cout << "1: ѧϢ" << endl;
	cout << "2: Ϣ" << endl;
	cout << "3: ѧɼѯ" << endl;
	cout << "q: ˳" << endl;
	cin >> choice;
	switch (choice) {
	case '1':
		status = 1;
		break;
	case '2':
		status = 2;
		break;
	case '3':
		status = 3;
		break;
	case 'q':
	case 'Q':
		status = -1;
		break;
	}
}
//status 1
void Manager::stuPage() {
	char choice = '0';
	cout << "˵-ѧ" << endl;
	cout << "ѡ" << endl;
	cout << "1: ȫѧϢ" << endl;
	cout << "2: ѧ" << endl;
	cout << "3: ѧϢ" << endl;
	cout << "4: ༭/ɾѧ" << endl;
	cout << "5: ȫѧϢCSV" << endl;
	cout << "6: CSVѧϢ" << endl;
	cout << "b: " << endl;
	cin >> choice;
	switch (choice) {
	case '1':
		status = 11;
		break;
	case '2':
		status = 12;
		break;
	case '3':
		status = 13;
		break;
	case '4':
		status = 14;
		break;
	case '5':
		status = 15;
		break;
	case '6':
		status = 16;
		break;
	case 'b':
	case 'B':
		goBack();
	}
}
//status 11
void Manager::stuDspPage() {
	cout << "˵-ѧ-Ϣ鿴" << endl;
	cout << setw(6) << "";
	Student::dspHeader();
	cout << endl;
	int count = 1;
	for (auto student = Students.begin(); student < Students.end(); student++) {
		cout << setw(6) << count++;
		student->dsp();
		cout << endl;
	}
	string tmp;
	cout << endl << "b: " << endl;
	cin >> tmp;
	goBack();
}
//status 12
void Manager::stuAddPage() {
	char choice = '0';
	cout << "˵-ѧ-" << endl;
	int year;
	int selectionNo;
	int classNo;
	char name[100];
	cout << ":" << endl;
	do {
		cin.getline(name, 100);
	} while (name[0] == '\0');
	cout << "ѧ:" << endl;
	cin >> year;
	cout << "ѡ:" << endl;
	cin >> selectionNo;
	cout << "༶:" << endl;
	cin >> classNo;
	if (!cin.good()) {
		throw InputError("ַǷ!");
	}
	Students.push_back(Student(year, selectionNo, classNo, name));
	cout << "ӣ" << endl;
	string tmp;
	cout << endl << "b: " << endl;
	cin >> tmp;
	goBack();
}
//status 13
void Manager::stuSearchPage() {
	char choice = '0';
	cout << "˵-ѧ-" << endl;
	cout << "ѡ:" << endl;
	cout << "1: ѧ" << endl;
	cout << "2: " << endl;
	cout << "3: ༶" << endl;
	cout << "4: ѡ" << endl;
	cout << "5: ѧ" << endl;
	cout << "b: " << endl;
	cin >> choice;
	vector<Student> result;
	int enrollmentYear;
	switch (choice) {
	case '1':
		long long int inputNo;
		cout << "ѧ:";
		cin >> inputNo;
		if (!cin.good()) {
			throw InputError("ַǷ!");
		}
		for (auto stu = Students.begin(); stu < Students.end(); stu++) {
			if (stu->stuNoEqual(inputNo)) {
				result.push_back(*stu);
			}
		}
		break;
	case '2':
		char inputName[100];
		cout << "ѧ:";
		do {
			cin.getline(inputName, 100);
		} while (inputName[0] == '\0');
		for (auto stu = Students.begin(); stu < Students.end(); stu++) {
			if (stu->nameEqual(inputName)) {
				result.push_back(*stu);
			}
		}
		break;
	case '3':
		int inputClassNo;
		cout << "ѧ:";
		cin >> enrollmentYear;
		cout << "༶:";
		cin >> inputClassNo;
		if (!cin.good()) {
			throw InputError("ַǷ!");
		}
		for (auto stu = Students.begin(); stu < Students.end(); stu++) {
			if (stu->clsNoEqual(inputClassNo) && stu->yearEqual(enrollmentYear)) {
				result.push_back(*stu);
			}
		}
		break;
	case '4':
		int inputSelectionNo;
		cout << "ѧ:";
		cin >> enrollmentYear;
		cout << "ѡ:";
		cin >> inputSelectionNo;
		if (!cin.good()) {
			throw InputError("ַǷ!");
		}
		for (auto stu = Students.begin(); stu < Students.end(); stu++) {
			if (stu->slcNoEqual(inputSelectionNo) && stu->yearEqual(enrollmentYear)) {
				result.push_back(*stu);
			}
		}
		break;
	case '5':
		cout << "ѧ:";
		cin >> enrollmentYear;
		if (!cin.good()) {
			throw InputError("ַǷ!");
		}
		for (auto stu = Students.begin(); stu < Students.end(); stu++) {
			if (stu->yearEqual(enrollmentYear)) {
				result.push_back(*stu);
			}
		}
		break;
	case 'b':
	case 'B':
		goBack();
	}
	if (status != 1) {
		cout << setw(6) << "";
		Student::dspHeader();
		cout << endl;
		int count = 1;
		for (auto student = result.begin(); student < result.end(); student++) {
			cout << setw(6) << count++;
			student->dsp();
			cout << endl;
		}
		cout << endl;
		if (result.size() == 0) {
			cout << "δҵѧ" << endl;
		}
		cout << "b: " << endl;
		string tmp;
		cin >> tmp;
		goBack();
	}
}
//status 14
void Manager::stuEdtRmvPage() {
	int inputNo;
	string tmp;
	cout << "˵-ѧ-༭/ɾ" << endl;
	cout << "ѧ:";
	cin >> inputNo;
	if (!cin.good()) {
		throw InputError("ַǷ!");
	}
	auto it = Students.end();
	for (auto stu = Students.begin(); stu < Students.end(); stu++) {
		if (stu->stuNoEqual(inputNo)) {
			it = stu;
		}
	}
	if (it == Students.end()) {
		cout << "޴" << endl;
		cout << "b: " << endl;		
		cin >> tmp;
		goBack();
	}
	else {
		char choice;
		cout << "1: ༭ѧϢ" << endl;
		cout << "2: ɾ" << endl;
		cin >> choice;
		Student::dspHeader();
		cout << endl;
		it->dsp();
		cout << endl;
		if (choice == '1') {

			int year;
			int selectionNo;
			int classNo;
			char name[100];
			cout << ":" << endl;
			do {
				cin.getline(name, 100);
			} while (name[0] == '\0');
			cout << "ѧ:" << endl;
			cin >> year;
			cout << "ѡ:" << endl;
			cin >> selectionNo;
			cout << "༶:" << endl;
			cin >> classNo;
			if (!cin.good()) {
				throw InputError("ַǷ!");
			}
			it->setInfo(year, selectionNo, classNo, name);
			cout << "޸" << endl;
		}
		else if (choice == '2') {
			cout << "ɾѧ?(Y()/N())" << endl;
			char yorn;
			cin >> yorn;
			if (yorn == 'y' || yorn == 'Y') {
				Students.erase(it);
			}
			cout << "ɾ" << endl;
		}
		cout << "b: " << endl;
		string tmp;
		cin >> tmp;
		goBack();
	}
}
//status 15
void::Manager::stuExportPage() {
	cout << "˵-ѧ-" << endl;
	string csvName;
	cout << "뵼ļ:" << endl;
	do {
		getline(cin, csvName);
	} while (csvName == "");	
	csvName = csvName + ".csv";
	ofstream csv(csvName);
	if (!csv.good()) {
		throw FileError("ļʧ!");
	}
	Student::toCsvHeader(csv);
	csv << '\n';
	for (auto student = Students.begin(); student < Students.end(); student++) {
		student->toCsv(csv);
		csv << '\n';
	}
	string tmp;
	cout << "ɹ" << endl;
	cout << "b: " << endl;
	cin >> tmp;
	goBack();
}
//status 16
void::Manager::stuImportPage() {
	string fileName;
	string tmp;
	bool eof = false;
	int firstRow=1;
	int clsColumn, slcColumn, yearColumn,nameColumn;
	cout << "˵-ѧ-" << endl;
	cout << "ļƻ·עչ" << endl;
	cin >> fileName;
	if (!cin.good()) {
		throw InputError("ַǷ!");
	}
	ifstream csvFile(fileName);
	if (!csvFile.good()) {
		throw FileError("ļʧ!");
	}
	cout << "Чݿʼ: " << endl;
	cin >> firstRow;
	cout << "ѧڵ: " << endl;
	cin >> nameColumn;
	cout << "ѧڵ: " << endl;
	cin >> yearColumn;
	cout << "ڵ: " << endl;
	cin >> clsColumn;
	cout << "ѡڵ: " << endl;
	cin >> slcColumn;
	if (!cin.good()) {
		throw InputError("ַǷ!");
	}
	for (int i = 1; i < firstRow; i++) {
		getline(csvFile, tmp);
	}
	while (!eof) {
		Student tmpStu(csvFile, yearColumn, clsColumn, slcColumn, nameColumn);
		if (tmpStu.stuNoEqual(-1)) {
			eof = true;
			
		}
		else if (tmpStu.stuNoEqual(0)) {
			continue;
		}
		else {
			Students.push_back(tmpStu);
		}
	}

	cout << "ѵ" << endl;
	cout << "b: " << endl;
	cin >> tmp;
	goBack();
}
//status 2
void Manager::examPage() {
	char choice = '0';
	cout << "˵-" << endl;
	cout << setw(6) << "";
	Exam::dspHeader();
	for (auto exam = Exams.begin(); exam < Exams.end(); exam++) {
		cout << setw(4) << distance(Exams.begin(), exam) + 1;
		(*exam)->dsp();
	}
	cout << endl;
	cout << "ѡ" << endl;
	cout << "1: ӿ" << endl;
	cout << "2: ѡ" << endl;
	cout << "b: " << endl;
	cin >> choice;
	switch (choice) {
	case '1':
		status = 21;
		break;
	case '2':
		status = 22;
		break;
	case 'b':
	case 'B':
		goBack();
		break;
	}
}
//status 21
void Manager::examAddPage() {
	cout << "˵--" << endl;
	cout << ":" << endl;
	char name[100];
	do {
		cin.getline(name, 100);
	} while (name[0] == '\0');
	auto p = make_shared<Exam>(name);
	Exams.push_back(p);
	cout << "ӳɹ!" << endl;
	cout << "b: " << endl;
	string tmp;
	cin >> tmp;
	goBack();
}
//status 22
void Manager::examChoosePage() {
	int examNo;
	string tmp;
	cout << "˵--ѡ" << endl;
	cout << setw(6) << "";
	Exam::dspHeader();
	for (auto exam = Exams.begin(); exam < Exams.end(); exam++) {
		cout << setw(6) << distance(Exams.begin(), exam) + 1;
		(*exam)->dsp();
	}
	cout << endl;
	cout << ":" << endl;
	cin >> examNo;
	if (!cin.good()) {
		throw InputError("ַǷ!");
	}
	examNo--;
	if (examNo >= 0 && examNo < Exams.size()) {
		currentExam = Exams.begin() + examNo;

		status = 23;
	}
	else {
		throw IndexError("Ч!");
	}
}
//status 23
void Manager::examSubPage() {
	cout << "˵--";
	(*currentExam)->dspName();
	cout << endl;

	cout << "ѡ:" << endl;
	cout << "1: 鿴ȫɼ" << endl;
	cout << "2: ΪCSV" << endl;
	cout << "3: ɼ" << endl;
	cout << "4: ɾɼ" << endl;
	cout << "5: ޸Ŀ" << endl;
	cout << "6: CSV" << endl;
	cout << "7: ɾ˿ԼгɼϢ" << endl;
	cout << "b: " << endl;
	char choice = '0';
	cin >> choice;
	switch (choice) {
	case '1':
		status = 231;
		break;
	case '2':
		status = 232;
		break;
	case '3':
		status = 233;
		break;
	case '4':
		status = 234;
		break;
	case '5':
		status = 235;
		break;
	case '6':
		status = 236;
		break;
	case '7':
		status = 237;
		break;
	case 'b':
	case 'B':
		goBack();
	}
}
//status 231
void Manager::examViewPage() {

	cout << "˵--";
	(*currentExam)->dspName();
	cout << "-鿴" << endl;
	Item::dspHeader();
	cout <<setw(6)<< "" << endl;
	(*currentExam)->dspItems();
	string tmp;
	cout << endl << "b: " << endl;
	cin >> tmp;
	goBack();
}
//status 232
void Manager::examExportPage() {

	string csvName;

	cout << "˵--";
	(*currentExam)->dspName();
	cout << "-" << endl;
	cout << "뵼ļ:" << endl;
	do {
		getline(cin, csvName);
	} while (csvName == "");	
	csvName = csvName + ".csv";
	ofstream csv(csvName);
	if (!csv.good()) {
		throw FileError("ļʧ!");
	}
	Item::toCsvHeader(csv);
	csv << "" << endl;
	(*currentExam)->toCsvItems(csv);
	csv.close();
	cout << "" << endl;
	string tmp;
	cout << endl << "b: " << endl;
	cin >> tmp;
	goBack();
}
//status 233
void Manager::examAddRowPage() {
	long long int studentNo;
	double score[9];
	char yorn;

	cout << "˵--";
	(*currentExam)->dspName();
	cout << "-ɼ" << endl;

	cout << "ѧ:" << endl;
	cin >> studentNo;
	if (!cin.good()) {
		throw InputError("ַǷ!");
	}
	if ((*currentExam)->itemExists(studentNo)) {
		cout << "ѧ" << studentNo << "ĳɼѴ, Ƿ񸲸? (Y()/N())" << endl;
		cin >> yorn;
		if (yorn != 'Y' && yorn != 'y') {
			status = 23;
			return;
		}
	}
	cout << "ѧ:" << endl;
	cin >> score[0];
	cout << ":" << endl;
	cin >> score[1];
	cout << "Ӣ:" << endl;
	cin >> score[2];
	cout << ":" << endl;
	cin >> score[3];
	cout << "ѧ:" << endl;
	cin >> score[4];
	cout << ":" << endl;
	cin >> score[5];
	cout << "ʷ:" << endl;
	cin >> score[6];
	cout << ":" << endl;
	cin >> score[7];
	cout << ":" << endl;
	cin >> score[8];	
	if (!cin.good()) {
		throw InputError("ַǷ!");
	}
	(*currentExam)->addItem(studentNo, score);
	cout << "" << endl;
	string tmp;
	cout << endl << "b: " << endl;
	cin >> tmp;
	goBack();
}
//status 234
void Manager::examDelRowPage() {
	char yorn;
	long long int studentNo;
	string tmp;

	cout << "˵--";
	(*currentExam)->dspName();
	cout << "-ɾɼ" << endl;

	cout << "ѧ:" << endl;
	cin >> studentNo;
	if (!cin.good()) {
		throw InputError("ַǷ!");
	}
	cout << "ȷɾ(Y()/N())" << endl;
	cin >> yorn;
	if (yorn == 'Y' || yorn == 'y') {
		yorn=(*currentExam)->rmvItem(studentNo);
		if (yorn) {
			cout << "ɾ" << endl;
		}
		else {
			cout << "δҵ" << endl;
		}
	}
	else {
		cout << "ȡ" << endl;
	}
	cout << "b: " << endl;
	cin >> tmp;
	goBack();
}
//status 235
void Manager::examNamePage() {
	string tmp;
	char name[100];
	cout << "˵--";
	(*currentExam)->dspName();
	cout << "-޸" << endl;
	cout << ":" << endl;
	do {
		cin.getline(name, 100);
	} while (name[0] == '\0');
	(*currentExam)->changeName(name);
	cout << "޸" << endl;
	cout << "b: " << endl;
	cin >> tmp;
	goBack();
}
//status 236
void Manager::examImportPage() {
	string tmp;
	string fileName;
	int firstRow;
	int stuNoColumn;
	int scoreColumn[9];
	bool eof=false;
	char name[100];
	cout << "˵--";
	(*currentExam)->dspName();
	cout << "-" << endl;
	cout << "ע⣬˿ѴͬѧѧĳɼݣCSVݻὫ串" << endl;
	cout << "ļƻ·עչ" << endl;
	cin >> fileName;
	ifstream csvFile(fileName);
	if (!csvFile.good()) {
		throw FileError("ļʧ!");
	}
	cout << "Чݿʼ: " << endl;
	cin >> firstRow;
	cout << "ѧڵ" << endl;
	cin >> stuNoColumn;
	cout << "ѧġӢѧʷΡɼڵԿոָ" << endl;
	cin >> scoreColumn[0] >> scoreColumn[1] >> scoreColumn[2] >> scoreColumn[3] >> scoreColumn[4] >> scoreColumn[5] >> scoreColumn[6] >> scoreColumn[7] >> scoreColumn[8];
	if (!cin.good()) {
		throw InputError("ַǷ!");
	}
	for (int i = 1; i < firstRow; i++) {
		getline(csvFile, tmp);
	}
	while (!eof) {
		Item tmpItem(csvFile, stuNoColumn, scoreColumn);
		if (tmpItem.getStuNo()==-1) {			
			eof = true;
		}
		else if(tmpItem.getStuNo()==0) {
			continue;
		}
		else {
			(*currentExam)->addItem(tmpItem);
		}
	}

	cout << "ѵ" << endl;
	cout << "b: " << endl;
	cin >> tmp;
	goBack();
}
//status 237
void Manager::examRmvPage() {
	string tmp;

	cout << "˵--";
	(*currentExam)->dspName();
	cout << "-ɾ" << endl;
	cout << "ȷҪɾ\"";
	(*currentExam)->dspName();
	cout<< "\"" << endl;
	cout << " \"confirm\" ȷɾ" << endl;
	cin >> tmp;
	if (tmp == "confirm") {
		(*currentExam)->rm();
		Exams.erase(currentExam);
		currentExam = Exams.begin();
		goBack();
		goBack();
		cout << "ɾ" << endl;
	}
	else {
		goBack();
		cout << "ȡ" << endl;
	}
	cout << "b: " << endl;
	cin >> tmp;

}
//status 3
void Manager::stuPfmPage() {
	long long int studentNo;
	cout << "˵-ѧɼѯ" << endl;
	cout << "ѧ:" << endl;
	cin >> studentNo;
	if (!cin.good()) {
		throw InputError("ַǷ!");
	}
	Student::dspHeader();
	cout << endl;
	if (searchByNo(studentNo) == nullptr) {
		cout << setw(20) << "δҵ" << endl;
	}
	else {
		searchByNo(studentNo)->dsp();
	}
	cout << endl << endl;
	cout << "οԳɼ:" << endl<<endl;
	cout << setw(20) << "";
	Item::dspHeader(0);
	cout << setw(6) << "" << endl;
	for (auto exam = Exams.begin(); exam < Exams.end(); exam++) {
		auto item = (*exam)->StudentInquiry(studentNo);
		(*exam)->dspName(20);
		if (item == nullptr) {
			cout << setw(20) << "δҵ" << endl;
		}
		else {
			item->dsp(0);
			cout << setw(6)<<(*exam)->getStuRanking(*item)<<endl;
		}
	}
	string tmp;
	cout <<endl<< "b: " << endl;
	cin >> tmp;
	goBack();
}
