#pragma once
#include<fstream>
#include<iomanip>
#include<iostream>
#include<string>
#include<vector>
using namespace std;

class Student {
public:
	Student(int year, int selectionNo, int classNo, char name[]);
	Student(long long int studentNo);
	Student(ifstream& csv, int yearColumn, int clsColumn, int slcColumn,int nameColumn);
	Student(){}

	void setInfo(int year, int selectionNo, int classNo, char name[]);
	bool stuNoEqual(long long int studentNo) const;
	bool slcNoEqual(int selectionNo) const;
	bool clsNoEqual(int classNo) const;
	bool yearEqual(int year) const;
	bool nameEqual(char name[]) const;	
	static void dspHeader();
	void dsp() const;
	static void toCsvHeader(ofstream& csv);
	void toCsv(ofstream& csv) const;
	static long long int infoToNo(int year,int selectionNo, int classNo);
	
	virtual ~Student(){};
private:
	long long int studentNo;
	char name[100];
	int year;
	int selectionNo;
	int classNo;
	int serialNo;
};
